/** 
 * @file WindowManager.cpp
 * @brief EBhE̐R[obN̓o^s
 * @author Iwata Naoki
 * @date 2011-03-19
 * @version 1.00
 * @version 1.01 2013/03/22 katayama
 * @version 1.02 2015/05/07 katayama
 *
 * Copyright (C) 2010 - TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]gp܂B
 */


/*--------- include ---------*/

#include "WindowManager.h"
#include "EventListener.h"

/*--------- window style` ---------*/
#define WS_WINDOW			(WS_CAPTION | WS_SYSMENU)

/*--------- ֐` ---------*/

/**
 * EBhẼCxg̃R[obN\n
 * Cxg̏̓bZ[WNbJ[gpčŝŁA\n
 * ̎@link EventListener.cpp @endlinkōs
 *
 * @param[in] hwnd    EBhEnh
 * @param[in] message R[obÑbZ[Wԍ
 * @param[in] wParam  Cxg̃p[^
 * @param[in] lParam  Cxg̃p[^
 *
 * @see http://msdn.microsoft.com/en-us/library/ms633573(VS.85).aspx
 *
 */
static LRESULT CALLBACK wndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam) {

	switch(message) {
		// bZ[WNbJ[
		HANDLE_MSG(hwnd, WM_CREATE,        onCreate);
		HANDLE_MSG(hwnd, WM_CLOSE,         onClose);
		HANDLE_MSG(hwnd, WM_DESTROY,       onDestroy);
		HANDLE_MSG(hwnd, WM_SIZE,          onSize);
		HANDLE_MSG(hwnd, WM_TIMER,         onTimer);
		HANDLE_MSG(hwnd, WM_KEYDOWN,       onKeydown);
		HANDLE_MSG(hwnd, WM_KEYUP,         onKeyup);
		HANDLE_MSG(hwnd, WM_PAINT,         onPaint);
		HANDLE_MSG(hwnd, WM_LBUTTONDOWN,   onLButtonDown);
		HANDLE_MSG(hwnd, WM_LBUTTONUP,     onLButtonUp);
		HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK, onLButtonDblClk);
		HANDLE_MSG(hwnd, WM_RBUTTONDOWN,   onRButtonDown);
		HANDLE_MSG(hwnd, WM_RBUTTONUP,     onRButtonUp);
		HANDLE_MSG(hwnd, WM_RBUTTONDBLCLK, onRButtonDblClk);
		HANDLE_MSG(hwnd, WM_MOUSEMOVE,     onMouseMove);
		default:
			break; 
	}

	return DefWindowProc(hwnd, message, wParam, lParam) ;
}


/**
 * Cʐ\n
 * Cʂ𐶐AnhԂ
 *
 * @param[in] hInstance CX^X
 * @param[in] title     EBhẼ^Cg
 * @param[in] x         XN[ɃEBhE\鍶XẄʒu
 * @param[in] y         EBhEYW
 * @param[in] w         EBhE
 * @param[in] h         EBhEc
 *
 * @return EBhEnh
 *
 */
extern HWND createMainWindow(HINSTANCE hInstance, const TCHAR* title, int x, int y, int w, int h) {

	WNDCLASS wndClass; // EBhENX\
	HWND     hWnd;     // EBhEnh

	TCHAR    className[] = "MAIN";
	
	wndClass.style         = CS_HREDRAW | CS_VREDRAW ;
	wndClass.lpfnWndProc   = wndProc ;
	wndClass.cbClsExtra    = 0 ;
	wndClass.cbWndExtra    = 0 ;
	wndClass.hInstance     = hInstance ;
	wndClass.hIcon         = LoadIcon(NULL, IDI_APPLICATION) ;
	wndClass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndClass.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wndClass.lpszMenuName  = NULL ;
	wndClass.lpszClassName = className;	
	
	if (!RegisterClass(&wndClass)) {
			MessageBox(NULL, TEXT ("This program requires Windows NT!"), className, MB_ICONERROR);
			return 0;
	}

	// Window̐
	hWnd = CreateWindow(className, title, WS_WINDOW, x, y, w, h, NULL, NULL, hInstance, NULL);

	return hWnd;

}

