/** 
 * @file rShare.cpp
 * @brief remote Shared Memory client program module 
 * 
 * @author Katayama
 * @date 2015-05-22
 * @version ver 1.00 2015/05/22 katayama
 *
 * Copyright (C) 2015 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */
#pragma warning(disable:4996)	// ZLeBアÂ֐ɑ΂x̉
#include <time.h>
#include <stdio.h>

#include "./include/TPUD_13dll.h"      // UDPʐM
#pragma comment(lib, "./lib/TPUD_13.lib")


static w32udp* rShare = NULL;		// remote share


/** initialize remote Share memory
 * @fn     int rSHA_init(char* host_ip, int port_no)
 * @param  host_ip  : Host IP address
 * @param  port_no  : rLOG TCP port no
 * @retval != 0     : OK
 * @retval == 0     : error
 *
 */
int rSHA_init(char* host_ip, int port_no)
{
	int ans = 0;
	int res;

	if (!rShare) {
		rShare = new w32udp("UDP_C");				// remote sharepUDP 
		if (rShare) {
			res = rShare->open(host_ip, port_no, 200);		// remote Share openiM҂F200msj
			if (res) {	// open error
				rShare->close();
				delete rShare;
				rShare = NULL;
				ans = 1;
			}
		}
	}
	return (ans);
}

/** close remote Share memory
 * @fn     int rSHA_close(void)
 * @retval != 0     : OK
 * @retval == 0     : error
 *
 */
int rSHA_close(void)
{
	int ans = 0;

	if (rShare) {
		rShare->close();
		delete rShare;
		rShare = NULL;
		ans = 1;
	}
	return (ans);
}

/** send remote Share memory
 * @fn     int rSHA_send(char* buf, int data_size)
 * @param  buf      : buffer address
 * @param  data_size: send data size
 * @retval >  0     : OK(send size)
 * @retval == 0     : error
 *
 */
int rSHA_send(char* buf, int data_size)
{
	int ans = 0;

	if (rShare) {
		ans = rShare->send(buf, data_size);
	}
	return (ans);
}

/** receive remote Share memory
 * @fn     int rSHA_recv(char* buf, int buf_size)
 * @param  buf      : buffer address
 * @param  data_size: buffer size
 * @retval >  0     : OK(receive size)
 * @retval == 0     : error
 *
 */
int rSHA_recv(char* buf, int buf_size)
{
	int ans = 0;

	if (rShare) {
		ans = rShare->recv(buf, buf_size);
	}
	return (ans);
}
